from __future__ import generators
import plus
import Arenas
import random
from random import randint
import Hazards
import math

class Seizure(Arenas.SuperArena):
    "This arena isn't just dangerous for the bots... it's also hazardous for your own health.  Enter at your own risk!"
    name = "Seizure Arena"
    preview = "seizure/seizure_preview.bmp"
    game_types = ['DEATHMATCH', 'BATTLE ROYAL', 'TEAM MATCH']
    extent = (-12, 12, 12, -12)

    def __init__(self):
        Arenas.SuperArena.__init__(self, "Arenas/seizure/seizure.gmf")
        plus.setBackColor(0,0,0)
        degrad = 0.01745
        self.AddStaticCamera("Static 1", (-20, 8, 15), (30*degrad, 128*degrad), degrad*55)
        self.AddStaticCamera("Static 2", (0, 30, 0), (90*degrad, 90*degrad), degrad*55)
        self.AddStaticCamera("Static 3", (0, -20, 0), (-90*degrad, 0), degrad*75)
        self.AddStaticCamera("Static Distortion", (0, 7.8, -18), (40*degrad, 0), degrad*220)

        self.AddWatchCamera("Watch Cam 1", (20, 15, -15), (20, 40, 50*degrad, 40*degrad))
        self.AddWatchCamera("Watch Cam 2", (-20, 8, 15), (12, 20, 40*degrad, 30*degrad))
        self.AddWatchCamera("Distortion Cam", (0, 0, 0), (2, 14, 315*degrad, 10*degrad))
        self.AddWatchCamera("Underworld Cam", (0, -20, 0), (20, 35, 50*degrad, 40*degrad))
        self.players = ()

        self.bgtimer = 0
        self.randcolor = 0

    def Activate(self, on):
        if on:
            self.players = plus.getPlayers()
        
        Arenas.SuperArena.Activate(self, on)
        
    def HazardsOn(self, on):
        if on:
            plus.Arena.__setattr__tickInterval__(Arenas.currentArena, 0.05)
            self.swirly = self.GetHinge("Hinge01")
            self.swirly.SetAutoLocks(False, False)
            self.swirly.Lock(False)
            self.swirly.SetPowerSettings(300,150)
            self.swirly.SetDirection(100)
        #walls
        self.AddCollisionLine((-12, 12), (12, 12))
        self.AddCollisionLine((12, 12), (12, -12))
        self.AddCollisionLine((12, -12), (-12, -12))
        self.AddCollisionLine((-12, -12), (-12, 12))
        
        return Arenas.SuperArena.HazardsOn(self, on)
        
    def __del__(self):
        plus.stopAllSounds()
        Arenas.SuperArena.__del__(self)
        
    def Tick(self):
        #Induce seizure
        if self.bHazardsOn and not plus.isMatchOver():
            self.randcolor = randint(0, 6)
            self.bgtimer += 1
            if self.bgtimer == 0 and self.randcolor == 0:
                plus.setBackColor(0,0,0)
            if self.bgtimer == 0 and self.randcolor == 1:
                plus.setBackColor(1,0,0)
            if self.bgtimer == 0 and self.randcolor == 2:
                plus.setBackColor(1,1,0)
            if self.bgtimer == 0 and self.randcolor == 3:
                plus.setBackColor(0,1,0)
            if self.bgtimer == 0 and self.randcolor == 4:
                plus.setBackColor(0,1,1)
            if self.bgtimer == 0 and self.randcolor == 5:
                plus.setBackColor(0,0,1)
            if self.bgtimer == 0 and self.randcolor == 6:
                plus.setBackColor(1,0,1)

            if self.bgtimer == 1:
                plus.setBackColor(1,1,1)
                self.bgtimer = -1
        else:
            plus.setBackColor(0,0,0)
            
        #check to see if anyone has been "eliminated" by falling off the tabletop
        #why is "eliminated" in quotes?
        for each in self.players:
            if plus.getLocation(each)[1] < -5:
                plus.eliminatePlayer(each)
            
        return Arenas.SuperArena.Tick(self)
        
Arenas.register(Seizure)